#ifndef TESTER_H
#define TESTER_H

#include "misc_utils.h"
#include "platform.h"
#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

#define wapp_tester_result(PASSED)                                             \
  ((TestFuncResult){.name = __func__, .passed = PASSED})
#define wapp_tester_run_tests(...) run_tests(__VA_ARGS__, NULL)

typedef struct test_func_result TestFuncResult;
struct test_func_result {
  const char *name;
  bool passed;

#ifdef WAPP_PLATFORM_WINDOWS
  wapp_misc_utils_padding_size(sizeof(const char *) + sizeof(bool));
#endif // WAPP_PLATFORM_WINDOWS
};

typedef TestFuncResult(TestFunc)(void);

void run_tests(TestFunc *func1, ...);

#ifdef __cplusplus
}
#endif // __cplusplus

#endif // !TESTER_H
